// create an nsIObserver implementor
function LOG(msg) {
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage(msg);
}
var MediaList={
	hunter:null,
	list:null,
	embedWindow:null,
	onLoad:function(){
		this.list = document.getElementById("netvideohunterMediaList");
		this.hunter = window.arguments[0];
		this.updateList()        
		if (this.hunter.mediaList.length>0 && document.getElementById("autoplay").getAttribute("checked")){
			this.insertPlayer(this.hunter.mediaList[0].url)
		}
	},

	updateList:function(){	
		//clear list
		while (this.list.childNodes.length > 0) {
			this.list.removeChild(this.list.childNodes[0]);
		}

		for (var x = 0; x < this.hunter.mediaList.length; x++) {		
			 
			var rli = document.createElement("richlistitem");			
			rli.setAttribute("mediaid",x);
			rli.setAttribute("type", "mediaitem");	
			rli.setAttribute("title", this.hunter.mediaList[x]['title']);
			rli.setAttribute("url", this.hunter.mediaList[x]['url']);
			rli.setAttribute("fileSize",this.formatFileSize(this.hunter.mediaList[x]['size']));
			this.list.appendChild(rli);
			
		}
	},

	formatFileSize:function(bytes){
		size = bytes / 1024;
		if(size < 1024){
			size = Math.round(size*100)/100;
			size += ' KB';
		}else {
			if(size / 1024 < 1024) {
				size = 	Math.round(size / 1024*100)/100					
				size += ' MB';
			} else if(size / 1024 / 1024 < 1024) {
				size = Math.round(size / 1024 / 1024 *100)/100					
				size += ' GB';
			}
		}
		return size;	
	},

	clearList:function(){
		if(this.hunter)
			this.hunter.clearMediaList();
		this.updateList()
	},
	performCommand:function (aCmd, aItem){
		if (!aItem) {
			aItem= this.list.selectedItem;
		} else {
			while ((aItem.nodeName != "richlistitem" || aItem.getAttribute("type") != "mediaitem") && aItem.parentNode){				
                aItem = aItem.parentNode;
                
			}
		}
		var id=aItem.getAttribute("mediaid");
		if(aCmd=="download"){
			this.hunter.download(id)
		}
        if(aCmd=="downloadcache"){
			this.hunter.download(id,false)
		}
        if(aCmd=="openpage"){
			this.hunter.openPage(id)
		}
		if(aCmd=="play"){
			this.insertPlayer(this.hunter.mediaList[id].url);
		}	 
		if(aCmd=="copy"){
			this.copyURL(id)
		}
		if(aCmd=="embed"){
			this.openEmbed(id)					
		}
	},

	openEmbed:function(id){
		this.embedWindow = window.openDialog("chrome://cliptatoolbar/content/embed.xul","cliptaEmbedWindow","dialog=no,width=710,height=380,chrome",this.hunter,id);
		this.embedWindow.focus();
	},
	insertPlayer:function(url){		
		url=this.addQueryParam(url,'nvhnocache','1')
		url=encodeURIComponent(url)
		var embed='<html:embed src="chrome://cliptatoolbar/content/player_toolbar.swf" id="player" wmode="opaque" allowfullscreen="true" allowscriptaccess="always"  width="100%" height="100%" flashvars="autostart=true&amp;file='+url+'" />'
		document.getElementById("playerDiv").innerHTML=embed
        document.getElementById("playerDiv").setAttribute("style","overflow:hidden")
	},
	addQueryParam:function(source,param,value){
	  if(source.indexOf("?")==-1){
		source+="?"
	  }
	  urlsplit=source.split("?")
	  urlsplit[1]+="&"+param+"="+value
	  return urlsplit.join("?")
	},
	copyURL:function(id){
		const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].
                                    getService(Components.interfaces.nsIClipboardHelper);
		gClipboardHelper.copyString(this.hunter.mediaList[id].url);

	}
	
}
