/*  
 Video Downloader Clipta Toolbar Edition
 Created by Peter Szabo (szpetr@gmail.com) 
*/

var prefs = Components.classes["@mozilla.org/preferences-service;1"].
              getService(Components.interfaces.nsIPrefBranch);

var clipta_embedIds=new Array();
clipta_embedIds["youtube"]="embed_code"
clipta_embedIds["metacafe"]="EmbedCode"
clipta_embedIds["livevideo"]="ctl00_ContentPlaceHolder1_embedCode"
clipta_embedIds["rutube"]="pcode_main"
clipta_embedIds["youku"]="link3"


function MediaData(){
	this.url=null,
	this.title=null,
	this.contentType=null,
	this.type=null,
	this.pageUrl=null,
	this.size=null,
	this.subject=null,
	this.extension=null,
	this.embedCode=null,
	this.site=null,

	this.cleanProperties=function(){
		if(this.contentType=="video/flv") this.contentType="video/x-flv";
		this.cleanUrl()
	},

	//detecting filetypes to capture only media links (using file extensions, contenttype header, and filesize)
	this.detectFileType=function(){
		this.type=false
		 if(this.url)
			this.extension=this.url.substr(this.url.lastIndexOf(".")+1,3);      
		 if(this.contentType){
			 if(this.size < 100000 ) return false;
			 if(
					this.contentType.indexOf("video/x-flv")!=-1 ||
					this.contentType.indexOf("video/flv")!=-1 ||						 
					this.extension=="flv" || 
					this.extension=="mp4" ||	
					(
						this.contentType.indexOf("application/octet-stream")!=-1 && 
						(
						  this.extension!="zip" &&
						  this.extension!="js" &&
						  this.extension!="exe" && 
						  this.extension!="jpg" && 
						  this.extension!="gif" && 
						  this.extension!="png"
						) && 
						this.size > 200000
					) 
			 ){
					this.type="flv";
					if(this.extension=="mp4") this.type="mp4";
			 }else if(this.contentType.indexOf("audio/mpeg")!=-1 || this.ext=="mp3"){
					this.type="mp3";
			 }else if(this.contentType.indexOf("audio")!=-1 || this.contentType.indexOf("video")!=-1){
					this.type="";
					if(this.extension.length>0 && this.extension.length<=3){
						this.type=this.extension
					}
			 }
		 }
		 return this.type;
	},

	//cleaning the seek parameters from urls to prevent capturing the same video with different starting times
    this.cleanUrl=function () {	
      r=new RegExp("&(fs|start|begin)=[^&]+","g");     
      this.url=this.url.replace(r,"");
      r=new RegExp("(&ext=.flv){2,}","g");
      this.url=this.url.replace(r,"&ext=.flv");
      return this.url
    },

	this.detectSite=function(){
		this.site=this.pageUrl.substr(0,this.pageUrl.indexOf("/"))
		this.site=this.pageUrl.substr(this.pageUrl.lastIndexOf(".",this.pageUrl.lastIndexOf(".")))
		site=this.pageUrl.split("/")
		var arr=site[2].split(".")
		this.site=arr[arr.length-2]  
	},
	this.getEmbed=function(doc){		
		if(!this.grabCode(doc)){
			 var embeds = doc.getElementsByTagName("embed");
			 var maxArea = -1;
			 var width;
			 var height
			 var area;
			 var bigest;
			for (var i = 0; i < embeds.length; i++) { 				
				width=embeds[i].getAttribute("width");
				if(width.indexOf("%")!=-1) width=3000
				height=embeds[i].getAttribute("height");
				if(height.indexOf("%")!=-1) height=3000
				area=parseInt(width)*parseInt(height);
				if(area>maxArea){
					maxArea=area;
					bigest=embeds[i]
				} 						
			} 
			if(bigest) {
				var code=""
				if(bigest.parentNode.nodeName=="OBJECT"){
					 code="<"+bigest.parentNode.nodeName+" "
					for (i in bigest.parentNode.attributes){
						if(bigest.parentNode.attributes[i].value===undefined)  continue
						code+=bigest.parentNode.attributes[i].name+"='"+bigest.parentNode.attributes[i].value+"' "
					}
					code+=">"+bigest.parentNode.innerHTML+"</"+bigest.parentNode.nodeName+">"
				}else{
					code="<"+bigest.nodeName+" "
					for (i in bigest.attributes){
						if(bigest.attributes[i].value===undefined) continue
						code+=bigest.attributes[i].name+"='"+bigest.attributes[i].value+"' "
					}
					code+="/>"
				}
				code=code.replace(/(embed|autoPlay|autoplay|autoStart|autostart|isAutoPlay)=1/g,"$1=0")
				code=code.replace(/(embed|autoPlay|autoplay|autoStart|autostart|isAutoPlay)=true/g,"$1=false")
				this.embedCode=code	
			}
			
		} 		
		
	},
	this.grabCode=function(doc){  		
		var embedId=clipta_embedIds[this.site] 		
		if(embedId!=undefined && embedId!=null){
			 var e=doc.getElementById(embedId);
			 if(e){
				this.embedCode=e.value
				return true
			 }else{
				return false
			 }
		}else{
			return false
		}
	}
}

var NetVideoHunter={
  mediaList:[],			// storing data of the captured videos
  mediaListWin:null,
  embedWin:null,
  observe: function(aSubject, aTopic, aData) {
    if (aTopic == "http-on-examine-response") {
		try{
			aSubject.QueryInterface(Components.interfaces.nsIRequest);        
			var mData=new MediaData()
			mData.url=aSubject.name; 			
			aSubject.QueryInterface(Components.interfaces.nsIChannel); 	 			
			mData.contentType=aSubject.contentType
			mData.size=aSubject.contentLength
			type=mData.detectFileType();  
			if(type){ 			
				var win=aSubject.notificationCallbacks.getInterface(Components.interfaces.nsIWebNavigation);
												
				mData.title=win.document.title
				mData.pageUrl=win.document.location.href  				
				mData.subject=aSubject
				if(this.addMedia(mData)) {
					mData.detectSite()
					mData.getEmbed(win.document)   					
				}
										
			}else{
				delete(mData)	
			} 
		}catch (e) { LOG(e) }
    }    
    return true
  },

  addMedia: function(mData){
		if(mData.title=="Clipta Downloader") return false;		
		mData.cleanProperties()
		if(this.searchMediaList(mData)===false){			           
			this.mediaList.unshift(mData)
			this.update()
			return true
		}
  },

  searchMediaList:function (mData){
		var found=false;
        var videoid=false;		 
        if(mData.url.indexOf("ad.doubleclick.net")!=-1) return true;
		if(mData.url.indexOf("upload_status")!=-1) return true;
        if(mData.url.indexOf("youtube")!=-1 || mData.url.indexOf(".google")!=-1){
          var r=new RegExp("video_id=([^\&]+)","gi");
          var m = r.exec(mData.url);
          if (m != null) {         
            videoid=m[1]            
          }else{
            r=new RegExp("docid=([^\&]+)","gi");
            m = r.exec(mData.url);
            if (m != null) {         
              videoid=m[1]            
            }
          }          
        }
		if(mData.url.indexOf("dailymotion.com")!=-1){
		    r=new RegExp("\/flv\/([^\.]+)","gi");
            m = r.exec(mData.url);
            if (m != null) {         
              videoid=m[1]            
            }
		}
        if(videoid===false){
          for(i in this.mediaList){
              if(mData.url.indexOf(this.mediaList[i]['url'])!=-1){
                  found=i;
                  break;
              }
          }
        }else{          
          for(i in this.mediaList){
              if(this.mediaList[i]['url'].indexOf("video_id="+videoid)!=-1 || this.mediaList[i]['url'].indexOf("docid="+videoid)!=-1 || this.mediaList[i]['url'].indexOf("/flv/"+videoid+".flv")!=-1){
                  found=i;
                  break;
              }
          }
        }
		if(mData.title && mData.size){
			for(i in this.mediaList){
              if(this.mediaList[i]['title']==mData.title && this.mediaList[i]['size']==mData.size){
                  found=i;
                  break;
              }
			}
		}
        
		return found;
	},

  QueryInterface: function(aIID) {
	if (aIID.equals(Components.interfaces.nsISupports) ||
		aIID.equals(Components.interfaces.nsIObserver) )
	  return this;
	throw Components.results.NS_NOINTERFACE;
  },
	
	
	regListener: function(){      
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(NetVideoHunter, "http-on-examine-response", false);
		observerService.addObserver(NetVideoHunter, "http-on-modify-request", false);
	},

	unregListener: function(){
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver(NetVideoHunter, "http-on-examine-response");
		observerService.removeObserver(NetVideoHunter, "http-on-modify-request");
	},

    // updating the captured media counter and the medialist window if it's opened
    update: function(){
      var counter=document.getElementById("cliptaTB-nvh-Button");
      counter.setAttribute("label",NetVideoHunter.mediaList.length+" videos captured");
      if(this.mediaListWin && this.mediaListWin.MediaList){
          this.mediaListWin.MediaList.updateList()
      }
	},

	openMediaList:function(){		
		this.mediaListWin = window.openDialog("chrome://cliptatoolbar/content/mediaList.xul","netvideohunterMediaListWin", 
		"dialog=no,chrome,width=780,height=400",this,window);
		this.mediaListWin.focus();
	},
	
	clearMediaList:function(){
		this.mediaList=[];
		this.update()
	},

	download:function(id,bypassCache){
		if(typeof(bypassCache)=="undefined") bypassCache=true
		var filename=this.convertToFilename(this.mediaList[id].title)+"."+this.mediaList[id].type;
		//stat:
		var params="data[Videostat][mediaurl]="+encodeURIComponent(this.mediaList[id].url) 
		params+="&data[Videostat][pageurl]="+encodeURIComponent(this.mediaList[id].pageUrl)
		params+="&data[Videostat][title]="+encodeURIComponent(this.mediaList[id].title)
		params+="&data[Videostat][type]="+this.mediaList[id].type         
		Stat.send(params);
		//start saving:
        this.saveUrl(this.mediaList[id].url, filename, this.mediaList[id].contentType,bypassCache);
	},
    
    openPage: function (id) {
      gBrowser.addTab(this.mediaList[id].pageUrl);        
    },
	// stripping out special charaters to make cleaner filename
	convertToFilename:function(s){	
		s=s.substr(0,64);
		var r=new RegExp(" ","gi");
		s=s.replace(r,"_");
		r=new RegExp("[^A-z0-9\-\(\)_]","gi");
		s=s.replace(r,"");
		return s
	},
    
    performCommand:function (aCmd, aItem){		
        if(aCmd=="clear"){
          this.clearMediaList()
        }
    },
    
    saveUrl:function (aURL, aDefaultFileName, aContentType, aShouldBypassCache, aFilePickerTitleKey, aSkipPrompt){
      if (aSkipPrompt == undefined)  aSkipPrompt = false;    
      var file, fileURL;
      var fileInfo = new FileInfo(aDefaultFileName);      
        initFileInfo(fileInfo, aURL, null, null, aContentType, null);
        fileInfo.fileName = aDefaultFileName;
        fileInfo.fileBaseName = aDefaultFileName.substr(0,aDefaultFileName.lastIndexOf(".")-1);
        fileInfo.fileExt = aDefaultFileName.substr(aDefaultFileName.lastIndexOf(".")+1);    
        var fpParams = {
          fpTitleKey: aFilePickerTitleKey,
          isDocument: false,
          fileInfo: fileInfo,
          contentType: aContentType,
          saveMode: 0x00,
          saveAsType: 0,
          file: file,
          fileURL: fileURL
        };
        
        if (!getTargetFile(fpParams, aSkipPrompt))return;    
        saveAsType = fpParams.saveAsType;
        saveMode = fpParams.saveMode;
        file = fpParams.file;
        fileURL = fpParams.fileURL;    
        if (!fileURL)
            fileURL = makeFileURI(file);    
      // as converted text, pass the document to the web browser persist component.
      // If we're just saving the HTML (second option in the list), send only the URI.
      var source=fileInfo.uri;    
      var persist = makeWebBrowserPersist();    
      // Calculate persist flags.
      const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
      const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
      persist.persistFlags = flags;
      if(aShouldBypassCache){
         persist.persistFlags |= nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
      }
	  
      // Leave it to WebBrowserPersist to discover the encoding type (or lack thereof):
      persist.persistFlags |= nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
	  persist.persistFlags |= nsIWBP.PERSIST_FLAGS_DONT_CHANGE_FILENAMES
      // Create download and initiate it (below)
      var tr = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);    
        tr.init(source,fileURL, "", null, null, null, persist);		
        persist.progressListener = tr;
        persist.saveURI(source,null, null, null, null, fileURL);    
        
    },

    init:function(){ 
		initStat()
		window.addEventListener("load", this.regListener, false);
		window.addEventListener("unload", this.unregListener, false); 		
    }

}
var Stat=null;

NetVideoHunter.init()


//for debugging:
function LOG(msg) {
 // return false;
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage(msg);
}

// initializing the stat:
function initStat(){ 	
  Stat=new NVHHttpRequest()
  Stat.reqUrl="http://74.55.198.68/~clipta/stat/index.php/videostats/add";
  Stat.onLoad=function(success,response){		
      if(success && response && response.length>0){                
         LOG(response);                
      }	
  }	  
}

function NVHHttpRequest(){	
	var t=this
    this.enabled=true;
	this.reqUrl="";
    var req = Components.
              classes["@mozilla.org/xmlextras/xmlhttprequest;1"].
              createInstance();
 
    req.QueryInterface(Components.interfaces.nsIDOMEventTarget);
    req.addEventListener("load", function(){ 			
		if (req.readyState == 4) {
		 if (req.status == 200) {  		 		
			 t.onLoad(true,req.responseText)  			
		 } else {
			 t.onLoad(false)
		 }
	  }
	}, false);
    //req.addEventListener("error", onErrorFunc, false);    

    req.QueryInterface(Components.interfaces.nsIXMLHttpRequest);
	if(!req) return false;
	
	this.onLoad=function(success,response){};
	
	this.send=function(params,url){        
		if(!url) url=this.reqUrl
		params=this.encodeParams(params);
		req.abort()
		req.open('POST', url, true);
		req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		req.setRequestHeader("Content-length", params.length);
		req.setRequestHeader('X-Requested-With','XMLHttpRequest');
		req.setRequestHeader("Connection", "close");		
		req.send(params);		
	}
	
	this.encodeParams=function(params){
		if(!params) return '';
		var pairs=params.split("&");
		var key
		var value
		
		for(i in pairs){
			if(!pairs[i].indexOf) continue;
			key=pairs[i].substr(0,pairs[i].indexOf("=")) 
			key=encodeURIComponent(key);
			value=pairs[i].substr(pairs[i].indexOf("=")+1) 
			value=encodeURIComponent(value);	
			pairs[i]=key+"="+value;
		}		
		return pairs.join("&");
	}
}
